///////////////////////////////////////////////////////////////////////////////
//
//      Name   :    PCI7841.H (This header file is for DOS only)
//      Purpose:    cPCI/PCI-7841 Driver Include file
//      Version:    Gamma - 1
//      Date   :    1999/12/15
//      Author :    chuhwa
//      Copyright 1999 ADLink Technology 	
//      
//      Modified:   
//        1999/12/15  Rewritting for convenient using (Beta-4 to Gamma-1)
//
///////////////////////////////////////////////////////////////////////////////

#ifndef __PCI7841_H__
#define __PCI7841_H__

#include "typedef.h"

//  Card initialization and configuration functions
WORD GetDriverVersion(void);
int  _7841_FindAllCards(void);
int  _7841_OpenDriver(int card, int port);
int  _7841_CloseDriver(int handle);
int  _7841_ConfigPort(int handle, PORT_STRUCT *PortStruct);
int  _7841_GetPortStatus(int handle, PORT_STATUS *PortStruct);
int  _7841_DetectBaudrate(int handle, int miliSecs);
BYTE _7841_Read(int handle, int offset);
void _7841_Write(int handle, int offset, BYTE data);
//  use for cPCI-7841
int  _c7841_GetLedStatus(int handle, int index);
void _c7841_SetLedStatus(int handle, int index, int mode);

//  CAN layer functions
void CanEnableReceive(int handle);
void CanDisableReceive(int handle);
int  CanSendMsg(int handle, CAN_PACKET *packet);
int  CanRcvMsg(int handle, CAN_PACKET *packet);

//  CAN layer status control
//int  CanGetPortStatus(int handle, PORT_STATUS *PortStatus);
void CanClearOverrun(int handle);
void CanClearRxBuffer(int handle);
void CanClearTxBuffer(int handle);
BYTE CanGetArbitrationLostBit(int handle);
BYTE CanGetErrorCode(int handle);
BYTE CanGetErrorWarningLimit(int handle);
void CanSetErrorWarningLimit(int handle, BYTE limit);
BYTE CanGetRxErrorCount(int handle);
BYTE CanGetTxErrorCount(int handle);
void CanSetTxErrorCount(int handle, BYTE value);
BYTE _7841_GetIntStatusReg(int handle);
void far*_7841_InstallCallBack(int handle, int index, void (far* proc)() );
int _7841_RemoveCallBack(int handle, int index, void (far* proc)() );

//  DeviceNet layer functions
int  SendDeviceNetPacket(int handle, DEVICENET_PACKET* packet);
int  RcvDeviceNetPacket(int handle, DEVICENET_PACKET* packet);
int  SendGroup2Message(int handle, BYTE *argu);
int  RcvGroup2Message(int handle, BYTE* argu);
int  DNetSendIO(int handle, BYTE DestMAC_ID, int len, BYTE *argu);
int  DNetRcvIO(int handle, BYTE DestMAC_ID, BYTE *argu);
int  DNetOpenExp(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int  DNetCloseExp(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int  DNetOpenIO(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int  DNetCloseIO(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int  DNetScan(int handle, BYTE HostMAC_ID, BYTE* list);
int  DNetIdentity(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int Instance, int Attribute, BYTE* array);
int  DNetDNet(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int Instance, int Attribute, BYTE* array);
int  DNetSetID(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, BYTE newMAC_ID);
int  DNetSetBaud(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, BYTE NewBaudrate);
int  DNetAsmIn(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int Instance, int Attribute, BYTE* array);
int  DNetAsmOut(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int Instance, int Attribute, int len, BYTE *data);
int  DNetGetSafeOut(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int  DNetSetSafeOut(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, BYTE safeValue);
int  DNetConnExp(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int Attribute, BYTE* array);
int  DNetSetWDTime(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, unsigned short int time);
int  DNetSetWD(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, BYTE WDFlag);
int  DNetConnIO(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int Attribute, BYTE* array);
int  DNetDIP(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int Instance, int Attribute, BYTE* array);
int  DNetDOP(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int Instance, int Attribute, BYTE* array);
int  DNetSetDOP(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID,int Instance, int Attribute, int value);
int  DNetAIP(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int Instance, int Attribute, BYTE* array);
int  DNetSetAIP(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID,int Instance, int Attribute, int len, char* array);
int  DNetAOP(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID,int Instance, int Attribute, BYTE* array);
int  DNetSetAOP(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID,int Instance, int Attribute, int len, char* array);
int  DNetCIP(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int Instance, int Attribute, BYTE* array);
int  DNetSetCIP(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID,int Instance, int Attribute, int len, char* array);


//  Module layer functions
//  CAN-7000 common functions
int _7000_Open(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, BYTE mode);
int _7000_Close(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, BYTE mode);
int _7000_SetNewMACID(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, BYTE newMAC_ID);
int _7000_SetNewBaudrate(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, BYTE newBaudrate);
int _7000_GetBaudrate(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7000_GetMACID(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
long _7000_GetSerialNumber(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
short int _7000_GetFirmwareVersion(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7000_Reset(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7000_GetWatchDogTime(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7000_SetWatchDogTime(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, WORD rate);
int _7000_GetTimeOutAction(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7000_SetTimeOutAction(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, BYTE flag);

//  CAN-7013
int _7013_GetActive(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7013_SetActive(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, BYTE active);
unsigned short int _7013_GetAIRange(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7013_SetAIRange(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, unsigned short int value);
int _7013_ZeroCal(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7013_SpanCal(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
long _7013_GetAI(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel);
int _7013_GetAITemp(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel, char* array);

//  CAN-7017
int _7017_GetActive(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7017_SetActive(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, BYTE active);
unsigned short int _7017_GetAIRange(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7017_SetAIRange(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, unsigned short int value);
int _7017_ZeroCal(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7017_SpanCal(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
long _7017_GetAI(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel);
double _7017_GetAIVoltage(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel);

//  CAN-7018
unsigned short int _7018_GetActive(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7018_SetActive(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, BYTE active);
unsigned short int _7018_GetAIRange(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7018_SetAIRange(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, unsigned short int value);
int _7018_ZeroCal(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7018_SpanCal(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
double _7018_GetAI(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel);
double _7018_GetCJC(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel);
double _7018_GetCJCOffset(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7018_SetCJCOffset(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, double offset);
int _7018_GetCJCStatus(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7018_SetCJCStatus(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int mode);
int _7018_GetOpenDetectStatus(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7018_SetOpenDetectStatus(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int mode);
int _7018_GetOpenDetectChannelStatus(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7018_SetOpenDetectChannelStatus(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int mode);

//  CAN-7024
int _7024_SetTrimCal(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, BYTE offset);
int _7024_GetTrimCal(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int _7024_SetAO(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel, WORD value);
int _7024_SetAOVoltage(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel, double voltage);
int _7024_GetAO(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel);
double _7024_GetAOVoltage(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel);
int _7024_GetDI(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel);

//  CAN-7050
int _7050_GetDI(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel);
int _7050_SetDO(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel, BYTE value);
int _7050_GetDO(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel);

//  CAN-7054
int _7054_GetDI(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel);

//  CAN-7063
int _7063_SetDO(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel, BYTE value);
int _7063_GetDO(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel);


#endif      //  __PCI7841_H__

