/*
    Name : Object.h
    Fundmental DeviceNet Functions for Nudam 7000 Series Module
    ADLink Technology.
    Date : 1999/11/2
    Written by Chuhwa
    Versione : Gamma - 1
*/
#ifndef __OBJECT_H__
#define __OBJECT_H__
#include "typedef.h"
/*
        Nudam 7000 series private function
*/    
int _7000_WDF(int handle, BYTE DestMAC_ID);
int _7000_WSN(int handle, BYTE DestMAC_ID, DWORD SN);
int _7000_WriteEEPROM(int handle, BYTE DestMAC_ID, int index, DWORD data);
DWORD _7000_ReadEEPROM(int handle, BYTE DestMAC_ID, int index);

/*
	DeviceNet Identity Object Functions
*/
WORD GetVendor(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
WORD GetProductType(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
WORD GetProductCode(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
WORD GetProductRevision(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
WORD GetModuleStatus(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
DWORD GetSerialNumber(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
char* GetProductName(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);

/*
	DeviceNet DeviceNet Object Functions
*/
int GetNodeAddress(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int GetBaudrate(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int GetBOI(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int GetBusOffCounter(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
WORD GetAllocationInfo(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);

/*
	DeviceNet Connection Object Functions
*/
int GetConnExpState(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int GetConnExpInstanceType(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int GetConnExpTransportClassTrigger(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int GetWatchDogTime(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int GetTimeOutAction(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);

/*
    Digial Objects
*/
int GetDI(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel);
int GetDO(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, int channel);
/*
    Analog Objects
*/
int GetActive(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int SetActive(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, BYTE active);
unsigned short int GetAIRange(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);
int SetAIRange(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID, unsigned short int value);

/*
    Reset Command
*/
int Reset(int handle, BYTE HostMAC_ID, BYTE DestMAC_ID);

#endif
