///////////////////////////////////////////////////////////////////////////////
//
//      Name   :    TYPEDEF.H
//      Purpose:    cPCI/PCI-7841 driver structure define
//      Version:    Gamma - 1
//      Date   :    1999/12/15
//      Author :    chuhwa
//
//      Copyright 1999 ADLink Technology 	
//      
//      Modified:   
//
///////////////////////////////////////////////////////////////////////////////
#ifndef __TYPEDEF_H__
#define __TYPEDEF_H__

#ifndef BYTE
typedef unsigned char BYTE;
#endif  //  BYTE

#ifndef WORD
typedef unsigned short WORD;
#endif  //  WORD

#ifndef DWORD
typedef unsigned long DWORD;
#endif  //  DWORD

//  Define for can port struct
typedef struct _tagPORT_STRUCT
{
    int mode;       //  0   for 11-bit;     1 for 29-bit
    DWORD accCode, accMask;
    int baudrate;
}PORT_STRUCT;

//  Define can packet struct
typedef struct _tagCAN_PACKET
{
    DWORD CAN_ID;       //  CAN id
    BYTE rtr;           //  RTR bit
    BYTE len;           //  Data length
    BYTE data[8];       //  Data
    DWORD time;         //  Occur time (non use)
    BYTE reserved;      //  future use
}CAN_PACKET;

//  Define DeviceNet packet struct
typedef struct _tagDEVICENET_PACKET
{
    BYTE Group;         //  DeviceNet Group
    BYTE MAC_ID;        //  MAC_ID
    BYTE HostMAC_ID;    //  HostMAC_ID
    BYTE MESSAGE_ID;    //  Message ID
    BYTE len;           //  Data Length
    BYTE data[8];       //  Data
    DWORD time;         //  Occur time(for future use)
    BYTE reserved;      //  future use
}DEVICENET_PACKET;

//  Define CAN status register
/*
struct PORTREG_BIT
{
    unsigned short RxBuffer      : 1;
    unsigned short DataOverrun   : 1;
    unsigned short TxBuffer      : 1;
    unsigned short TxEnd         : 1;
    unsigned short RxStatus      : 1;
    unsigned short TxStatus      : 1;
    unsigned short ErrorStatus   : 1;
    unsigned short BusStatus     : 1;
    unsigned short reserved      : 8;
};
*/
struct PORTREG_BIT
{
    unsigned char RxBuffer      : 1;
    unsigned char DataOverrun   : 1;
    unsigned char TxBuffer      : 1;
    unsigned char TxEnd         : 1;
    unsigned char RxStatus      : 1;
    unsigned char TxStatus      : 1;
    unsigned char ErrorStatus   : 1;
    unsigned char BusStatus     : 1;
    //unsigned short reserved      : 8;
};

typedef union _tagPORT_REG
{
	struct PORTREG_BIT bit;
    unsigned char reg;
}PORT_REG;

typedef struct _tagPORT_STATUS
{
    PORT_STRUCT port;
    PORT_REG status;
}PORT_STATUS;

//  Define Product Code of Nudam 7000-series module
#define PRODUCT_7050            0x0001
#define PRODUCT_7054            0x0002
#define PRODUCT_7063            0x0003
#define PRODUCT_7013            0x0004
#define PRODUCT_7017            0x0005
#define PRODUCT_7018            0x0006
#define PRODUCT_7024            0x0007
#define PRODUCT_7080            0x0008

//  Define Product Type of DeviceNet 
#define GENERAL_DEVICE          0x0000
#define GENERAL_DISCRETE        0X0007
#define GENERAL_ANALOG          0x000A

//  Define Vendor
#define DEVICENET_VENDOR_ADLINK 0x01B2

#endif      //  __TYPEDEF_H__

